local NB = NotaBene
local L = NB.L

local options = {
	type = "group",
	handler = NotaBene,
	name = L["Nota Bene"],
	args = {
--[[
		general = {
			type = "group",
			name = L["General settings"],
			order = 1,
			args = {
			},
		},
		display = {
			type = "group",
			name = L["Display settings"],
			order = 2,
			args = {
				sink = NB:GetSinkAce3OptionsDataTable(),
			},
		},
		modules = {
			type = "group",
			name = L["Modules"],
			order = 2,
			args = {
				toggle = {
					type = "multiselect",
					name = L["Enable or disable specific modules"],
					order = 1,
					values = function()
						local modules = {}
						
						for k, v in UH:IterateModules() do
							modules[k] = v:GetName()
						end
						
						return modules
					end,
					get = function( info, key )
						return UH:GetModule( key ):IsEnabled()
					end,
					set = function( info, key, value )
						if value then
							UH:GetModule( key ):Enable()
						else
							UH:GetModule( key ):Disable()
						end
						
						UH.db.profile.modules[key] = value
					end
				},
			},
			plugins = { modules = {} },
		},
--]]
	},
}

--options.args.display.args.sink.order = 1
--options.args.display.args.sink.inline = true

function NotaBene:OnModuleCreated( module )
--[[
	if type( module.GetOptions ) == "function" then
		local moduleOptions = module:GetOptions()
		
		if moduleOptions then
			moduleOptions.hidden = function() return not module:IsEnabled() end
		end
		
		options.args.modules.plugins.modules[module:GetName()] = moduleOptions
	end
	
	self:NotifyOptionsChanged()
--]]
end

function NotaBene:InitializeOptions()
	-- Adding profiles
	options.args.profiles = LibStub( "AceDBOptions-3.0" ):GetOptionsTable( self.db )
	options.args.profiles.order = -1

	-- Registering
	LibStub( "AceConfig-3.0" ):RegisterOptionsTable( "NotaBene", options )
	self:RegisterChatCommand( "nb", function() LibStub( "AceConfigDialog-3.0" ):Open( "NotaBene" ) end )

	local ldb = LibStub:GetLibrary( "LibDataBroker-1.1" )
	
	if ldb then
		LibStub:GetLibrary( "LibDataBroker-1.1" ):NewDataObject( "Nota Bene", {
			type = "launcher",
			icon = "Interface\\Icons\\INV_Feather_16",
			OnClick = function( clickedframe, button )
				LibStub( "AceConfigDialog-3.0" ):Open( "NotaBene" )
			end,
		} )
	end
end

function NotaBene:NotifyOptionsChanged()
	LibStub( "AceConfigRegistry-3.0" ):NotifyChange( "NotaBene" )
end

function NotaBene:AddToplevelOptionsSection( name, section )
	assert( type( name ) == "string" )
	assert( type( section ) == "table" )
	
	options.args[name] = section
	
	self:NotifyOptionsChanged()
end

function NotaBene:AddGeneralOptionsSection( name, section )
	assert( type( name ) == "string" )
	assert( type( section ) == "table" )
	
	options.args.general.args[name] = section
	
	self:NotifyOptionsChanged()
end
