NotaBene.Debug = function() end
NotaBene.ModulePrototype.Debug = function() end


function NotaBene:CopyTable( src, dest )
	if type( dest ) ~= "table" then dest = {} end
	if type( src ) == "table" then
		for k, v in pairs( src ) do
			if type( v ) == "table" then
				-- try to index the key first so that the metatable creates the defaults, if set, and use that table
				v = self:CopyTable( v, dest[k] )
			end

			dest[k] = v
		end
	end

	return dest
end

--[===[@debug@
local debug = true

NotaBene:RegisterChatCommand( "nbd", function()
	if debug then
		NotaBene:Print( "Debug turned off." )
	else
		NotaBene:Print( "Debug turned on." )
	end
	
	debug = not debug
	end )

local function debugPrint( self, ... )
	if not debug then return end

	local count = select( "#", ... );
	local text = nil;

	if count == 0 then text = ""
	elseif count == 1 then text = tostring( select( 1, ... ) )
	elseif type( select( 1, ... ) ) == "string" and strfind( select( 1, ... ), "%%" ) then text = string.format( ... )
	else
		text = "";

		for i=1, count do
			if i > 1 then
				text = text..", "
			end

			text = text..tostring( select( i, ... ) )
		end
	end

	DEFAULT_CHAT_FRAME:AddMessage( "|cffff0000"..(self and tostring( self ) or "NotaBene")..": |r"..text );
end

NotaBene.Debug = debugPrint
NotaBene.ModulePrototype.Debug = debugPrint
--@end-debug@]===]
